﻿/****************************************************************************
**
** Copyright (C) 2013 Atmel Corporation and/or its subsidiary(-ies).
** All rights reserved.
**
** LIMITED License Agreement
**
** IT IS IMPORTANT THAT YOU READ THIS AGREEMENT CAREFULLY AND COMPLETELY.
** This Limited License Agreement (“Agreement”) is a legally binding agreement between,
** on one hand, either your employer (if you are acting on behalf of your employer)
** or you (if you are acting on your own behalf) (“Licensee”), and on the other hand,
** Atmel Corporation (“Atmel”).
**
** By installing or using any of the software downloaded or provided with these
** terms (“Licensed Software”), you are indicating that you are binding Licensee
** to the terms of this Agreement, and that you are duly authorized by Licensee to do so.
** If you are not authorized to bind Licensee to the terms of this Agreement,
** or if Licensee does not agree to be bound by all of the terms of this Agreement,
** do not install or use any such software.
**
**
** 1.	Grant of License.  Subject to the terms and conditions of this Agreement,
** Atmel grants Licensee a non-exclusive, non-transferable, non-sublicensable,
** limited license to use the Licensed Software solely in connection with Atmel products
** from SAM9 and SAMA5 families (“Atmel Product”).
**
** 2.	Restrictions.  Except as expressly set forth in Section 1, Licensee will not,
** and will have no right to, (a) use, copy or reproduce any Licensed Software except,
** (b) modify, create derivative works of, sell, distribute, transfer or disclose any
** Licensed Software. Without limiting the generality of the foregoing, Licensee will not,
** and will have no right to, use any Licensed Software for any semiconductor products
** that are not Atmel Products. Licensee will not remove, obscure or alter any trademark,
** copyright or other proprietary rights or ownership notices of Atmel that appear
** in any Licensed Software.
**
** 3.  	Title.  As between the parties, Atmel retains full rights, title, and ownership
** including all patents, copyrights, trade secrets, trade names, trademarks, and other
** intellectual property rights in and to the Licensed Software.
**
** 4.  	No Other Rights.  Except as expressly stated herein, this Agreement does not grant
** Licensee any rights to patents, copyrights, trade secrets, trade names, trademarks
** (whether registered or unregistered), or any other rights, franchises, or licenses
** in respect of the Licensed Software.
**
** 5.	Disclaimer of Warranty and No Support.  ALL LICENSED SOFTWARE IS PROVIDED “AS IS”,
** “WITH ALL FAULTS”, AND WITH NO WARRANTY WHATSOEVER.  ATMEL EXPRESSLY DISCLAIMS ALL
** WARRANTIES OF ANY KIND (WHEHTER EXPRESS, IMPLIED, STATUTORY OR OTHERWISE) IN CONNECTION
** WITH THE LICENSED SOFTWARE OR ANY OTHER ASPECT OF THIS AGREEMENT, INCLUDING, WITHOUT
** LIMITATION ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
** TITLE OR NON-INFRINGEMENT OF THIRD PARTY RIGHTS, AND ANY WARRANTIES THAT MAY ARISE
** FROM COURSE OF DEALING, COURSE OF PERFORMANCE OR USAGE OF TRADE.  ATMEL WILL HAVE
** NO OBLIGATION UNDER THIS AGREEMENT TO CORRECT ANY BUGS, DEFECTS OR ERRORS IN
** THE LICENSED SOFTWARE, PROVIDE ANY UPDATES, UPGRADES OR NEW RELEASES OF THE LICENSED SOFTWARE,
** OR OTHERWISE PROVIDE ANY SUPPORT OR MAINTENANCE FOR THE LICENSED SOFTWARE.
**
** 6.  	Export.  Licensee will comply with all applicable laws and regulations of all
** relevant jurisdictions in connection with its activities related to the Licensed Software.
** Without limitation of the foregoing, Licensee acknowledges that certain laws
** and regulations of the United States and other jurisdictions may pertain to the export
** and re-export of the Licensed Software, and Licensee will not export or re-export
** any Licensed Software in any form without the appropriate governmental approvals,
** or otherwise in violation of any such laws or regulations.
**
** 7.	Termination.  The license will automatically terminate if Licensee fails to comply
** with any of the terms and conditions of the license including, without limitation
** the confidentiality obligation or the obligations set forth in Sections 1, 2, 6, 7, 10
** and 11 herein. Upon termination for any reason, Licensee will immediately destroy
** or return to Atmel all whole or partial copies of the Licensed Software.
**
** 8.	High Risk Activities. LICENSEE ACKNOWLEDGES AND AGREES THAT THE LICENSED SOFTWARE
** IS NOT DESIGNED OR APPROVED FOR, AND WILL NOT BE INCORPORATED (WITHOUT THE EXPRESS WRITTEN
** APPROVAL OF AN OFFICER OF ATMEL) INTO, ANY PRODUCTS THAT ARE USED OR DESIGNED TO BE USED
** IN CONNECTION WITH ANY ACTIVITIES WHERE THE FAILURE OF SUCH PRODUCTS COULD REASONABLY
** BE EXPECTED TO RESULT IN DEATH, BODILY INJURY, OR SEVERE PHYSICAL OR ENVIRONMENTAL DAMAGE
** ("HIGH RISK ACTIVITIES").  IN NO EVENT WILL ATMEL HAVE ANY LIABILITY TO LICENSEE
** OR ANY THIRD PARTY ARISING OUT OF OR RELATED TO ANY USE OF LICENSED SOFTWARE IN CONNECTION
** WITH HIGH RISK ACTIVITIES, AND ATMEL HEREBY DISCLAIMS ANY EXPRESS OR IMPLIED WARRANTY OF
** FITNESS FOR ANY HIGH RISK ACTIVITIES.
**
** 9.  	LIMITATION OF LIABILITY.  TO THE EXTENT PERMITTED BY APPLICABLE LAW, IN NO EVENT WILL
** ATMEL BE LIABLE TO LICENSEE OR ANY THIRD PARTY (WHETHER SUCH LIABILITY IS BASED ON CONTRACT,
** NEGLIGENCE, STRICT LIABILITY, OTHER TORT THEORY, CONTRIBUTION, BREACH OF WARRANTY,
** OR OTHER LEGAL OR EQUITABLE THEORY) FOR ANY SPECIAL, INDIRECT, INCIDENTAL, EXEMPLARY,
** PUNITIVE OR CONSEQUENTIAL DAMAGES, OR ANY DAMAGES FOR LOSS OF PROFITS,
** LOSS OR INTERRUPTION OF BUSINESS, OR LOSS OF DATA, ARISING OUT OF OR RELATING TO
** THE LICENSED SOFTWARE OR ANY OTHER ASPECT OF THIS AGREEMENT, EVEN IF ATMEL has been advised
** of or should have known of the possibility of such damages.
**
** IN NO EVENT WILL ATMEL’S TOTAL LIABILITY ARISING OUT OF OR RELATED TO THE LICENSED SOFTWARE
** OR ANY OTHER ASPECT OF THIS AGREEMENT (WHETHER UNDER CONTRACT, NEGLIGENCE, STRICT LIABILITY,
** CONTRIBUTION, BREACH OF WARRANTY, OR OTHER LEGAL OR EQUITABLE THEORY) EXCEED THE GREATER OF
** (A) THE AGGREGATE OF ALL LICENSE FEES PAID BY LICENSEE TO ATMEL FOR THE LICENSED SOFTWARE, OR
** (B) ONE THOUSAND DOLLARS ($1,000). WITHOUT LIMITING THE FOREGOING,
** AND Notwithstanding any provision herein to the contrary, ATMEL will not be liable for
** ANY costs of PROCURING SUBSTITUTE GOODS, SERVICES OR TECHNOLOGY under any circumstances.
**
** Each Party acknowledges that THE OTHER PARTY has entered into this agreement in reliance
** on the limitations of liability, DISCLAIMERS OF WARRANTIES, EXCLUSION OF DAMAGES
** AND EXCLUSIVE REMEDIES contained in this AGREEMENT, AND THAT EACH OF THE FOREGOING PROVISIONS FORMS
** AN ESSENTIAL AND fundamental part of the basis of the bargain BETWEEN THE PARTIES,
** WITHOUT WHICH SUCH the other Party would not have entered into this Agreement.
** EACH PARTY AGREES THAT SUCH PROVISIONS WILL SURVIVE AND APPLY NOTWITHSTANDING ANY
** FAILURE OF ESSENTIAL PURPOSE OF ANY LIMITED REMEDY OR LIMITATION OF LIABILITY.
**
** 10.  	Governing Law; Dispute Resolution. This Agreement is to be construed in accordance
** with and governed by the internal laws of the State of California (as permitted by Section 1646.5
** of the California Civil Code or any similar successor provision), without giving effect
** to any choice of law rule that would cause the application of the laws of any jurisdiction
** other than the internal laws of the State of California to the rights and duties of the parties.
** This Agreement will not be governed by the U.N. Convention on the Sale of Goods,
** the application of which is expressly excluded. Except for actions for injunctive
** or other equitable relief, which may be brought in any court of competent jurisdiction,
** all disputes arising out of or related to this Agreement will be subject to the exclusive
** jurisdiction of the California state courts in Santa Clara County, California,
** or if there is exclusive federal jurisdiction, the United States District Court for
** the Northern District of California, and the Parties hereby consent to, and agree to submit to,
** the personal and exclusive jurisdiction and venue of such courts.
**
** 11. 	General. Licensee will not, and will have no right to, assign, delegate or otherwise
** transfer (whether voluntarily, by operation of law or otherwise) this Agreement or any of
** its rights or obligations hereunder to any third party without the prior written consent
** of Atmel, and any purported assignment, delegation or other transfer without such consent
** will have no force or effect. Subject to the foregoing, this Agreement will be binding upon
** and will inure to the benefit of the parties and their respective successors and permitted assigns.
** No failure of either party to enforce any right under this Agreement will be deemed a waiver
** of such right or any other right under this Agreement. Any waiver by a party of a breach
** of any provision of this Agreement by the other party hereunder will not be deemed to be
** a waiver of any subsequent breach of such provision or a waiver of any breach of any other
** provision of this Agreement.
** This Agreement may not be superseded, modified, or amended except in a writing signed by an officer
** of each party. If any provision of this Agreement is determined to be invalid, illegal
** or otherwise unenforceable, such provision will be enforced to the extent possible consistent
** with the intent of the parties, and the remaining provisions of this Agreement will remain in
** full force and effect. This Agreement will be fairly interpreted in accordance with its terms
** and without any strict construction against either party because it was drafted by such party
** or for any other reason. This Agreement will constitute the entire agreement between the parties
** relating to the subject matter hereof, and expressly supersedes and replaces all prior
** and contemporaneous agreements, proposals, quotations, negotiations and communications, written
** or oral, between the parties relating to such subject matter.
**
**
** Software Author: Timesys Corporation (www.timesys.com)
**
** Summary: Qt UI handling class for the Settings screen. Please consult settingsscreen.ui file for
**          object definitions
**
****************************************************************************/

#include <QPropertyAnimation>
#include <QParallelAnimationGroup>
#include <QPushButton>
#include <QLineEdit>
#include <QDebug>

#include "settingsscreen.h"
#include "ui_settingsscreen.h"


/***
 ** Default constructor
 ** Create objects for managing settings of the following features:
 ** - climate
 ** - lights
 ** - security
 ** - media
 ** - preferences
 **/
SettingsScreen::SettingsScreen(QWidget *parent) :
    QWidget(parent),
    ui(new Ui::SettingsScreen)
{
    ui->setupUi(this);

    if (isSmallResolution) {

        timer.setSingleShot(true);

        float wSFactor = 480. / 800.;
        float hSFactor = 272. / 480.;

        ui->label->setMaximumSize(ui->label->maximumWidth() * wSFactor, ui->label->maximumHeight() * hSFactor);
        ui->label->setMinimumSize(ui->label->minimumWidth() * wSFactor, ui->label->minimumHeight() * hSFactor);

        ui->label->setPixmap(QPixmap(QString::fromUtf8(":/resources/smalltopnav-all/title-settings.png")));
        ui->label_2->setPixmap(QPixmap(QString::fromUtf8(":/resources/smalltopnav-all/nav-filler.png")));

        ui->buttonSettingsClimate->setMinimumSize(ui->buttonSettingsClimate->minimumWidth() * wSFactor, ui->buttonSettingsClimate->minimumHeight() * hSFactor);
        QFont f = ui->buttonSettingsClimate->font();
        f.setPointSize(f.pointSize() * hSFactor);
        ui->buttonSettingsClimate->setFont(f);

        ui->buttonSettingsLighting->setMinimumSize(ui->buttonSettingsLighting->minimumWidth() * wSFactor, ui->buttonSettingsLighting->minimumHeight() * hSFactor);
        f = ui->buttonSettingsLighting->font();
        f.setPointSize(f.pointSize() * hSFactor);
        ui->buttonSettingsLighting->setFont(f);

        ui->buttonSettingsMedia->setMinimumSize(ui->buttonSettingsMedia->minimumWidth() * wSFactor, ui->buttonSettingsMedia->minimumHeight() * hSFactor);
        f = ui->buttonSettingsMedia->font();
        f.setPointSize(f.pointSize() * hSFactor);
        ui->buttonSettingsMedia->setFont(f);

        ui->buttonSettingsSecurity->setMinimumSize(ui->buttonSettingsSecurity->minimumWidth() * wSFactor, ui->buttonSettingsSecurity->minimumHeight() * hSFactor);
        f = ui->buttonSettingsSecurity->font();
        f.setPointSize(f.pointSize() * hSFactor);
        ui->buttonSettingsSecurity->setFont(f);

        ui->buttonSettingsPrefs->setMinimumSize(ui->buttonSettingsPrefs->minimumWidth() * wSFactor, ui->buttonSettingsPrefs->minimumHeight() * hSFactor);
        f = ui->buttonSettingsPrefs->font();
        f.setPointSize(f.pointSize() * hSFactor);
        ui->buttonSettingsPrefs->setFont(f);

        ui->label_2->setMaximumSize(ui->label_2->maximumWidth() * wSFactor, ui->label_2->maximumHeight() * hSFactor);
        ui->label_2->setPixmap(QPixmap(QString::fromUtf8(":/resources/smalltopnav-all/nav-filler.png")));

        ui->verticalLayout_3->setContentsMargins(ui->verticalLayout_3->contentsMargins().left() * wSFactor,
                                                 ui->verticalLayout_3->contentsMargins().right() * wSFactor,
                                                 ui->verticalLayout_3->contentsMargins().bottom() * hSFactor,
                                                 ui->verticalLayout_3->contentsMargins().top() * hSFactor);

        QPushButton *toggleButton = new QPushButton(this);
        toggleButton->setObjectName(QString::fromUtf8("toggleButton"));
        toggleButton->setFocusPolicy(Qt::NoFocus);
        toggleButton->setAutoFillBackground(false);
        toggleButton->setEnabled(true);
        toggleButton->setFlat(true);
        QImage img = QImage(":/resources/smallcamera/up.png");
        QMatrix matrix;
        matrix.rotate(90.);
        img = img.transformed(matrix);
        toggleButton->setIcon(QIcon(QPixmap::fromImage(img)));
        toggleButton->setMinimumSize(0,0);
        toggleButton->setMaximumSize(24,24);
        toggleButton->setSizePolicy(QSizePolicy::Maximum, QSizePolicy::Fixed);

        ui->topMenuLayout->addWidget(toggleButton);
        ui->topMenuLayout->setMargin(0);
        ui->topMenuLayout->setContentsMargins(0, 0, 8, 0);
        ui->topMenuWidget->setStyleSheet("background-color: rgb(21, 26, 32)");

        connect (toggleButton, SIGNAL(clicked()), this, SLOT(toggleMenus()));

        ui->verticalLayout_2->removeWidget(ui->topMenuWidget);
        ui->topMenuWidget->resize(450, 40);
        ui->topMenuWidget->move(-ui->topMenuWidget->width() + 35, 0);

        // Change paint order
        ui->topMenuWidget->stackUnder(this);
        ui->widgetGraphicsBox->stackUnder(ui->topMenuWidget);
        ui->verticalLayout_4->setContentsMargins(0, 0, 0, 0);

        QObject::connect(&timer, SIGNAL(timeout()), this, SLOT(toggleMenus()));

        QObject::connect(ui->buttonSettingsClimate, SIGNAL(clicked()), this, SLOT(runTimer()));
        QObject::connect(ui->buttonSettingsLighting, SIGNAL(clicked()), this, SLOT(runTimer()));
        QObject::connect(ui->buttonSettingsMedia, SIGNAL(clicked()), this, SLOT(runTimer()));
        QObject::connect(ui->buttonSettingsPrefs, SIGNAL(clicked()), this, SLOT(runTimer()));
        QObject::connect(ui->buttonSettingsSecurity, SIGNAL(clicked()), this, SLOT(runTimer()));

    } else {
        ui->label->setPixmap(QPixmap(QString::fromUtf8(":/resources/topnav-all/title-settings.png")));
        ui->label_2->setPixmap(QPixmap(QString::fromUtf8(":/resources/topnav-all/nav-filler.png")));
    }

    climateSettings = new ClimateSettings();
    prefsSettings = new PrefsSettings();
    lightingSettings = new LightingSettings();
    securitySettings = new SecuritySettings();
    mediaSettings = new MediaSettings();

    ui->graphicsWidgetLayout->addWidget(climateSettings);
    ui->graphicsWidgetLayout->addWidget(prefsSettings);
    ui->graphicsWidgetLayout->addWidget(lightingSettings);
    ui->graphicsWidgetLayout->addWidget(securitySettings);
    ui->graphicsWidgetLayout->addWidget(mediaSettings);

    prefsSettings->setVisible(false);
    lightingSettings->setVisible(false);
    securitySettings->setVisible(false);
    mediaSettings->setVisible(false);

    QObject::connect(qApp, SIGNAL(focusChanged(QWidget*, QWidget*)), this, SLOT(focusChanged(QWidget*, QWidget*)));
    QObject::connect(climateSettings, SIGNAL(sendingZonesInfo(QStringList&)), this, SLOT(sendingHVACZonesSlot(QStringList&)));

    ui->buttonSettingsClimate->setChecked(true);

}

/***
 ** Default destructor
 **/
SettingsScreen::~SettingsScreen()
{
    delete ui;
}


/*

Button handlers

*/

void SettingsScreen::clearButtonSelections()
{
    ui->buttonSettingsClimate->setChecked(false);
    ui->buttonSettingsLighting->setChecked(false);
    ui->buttonSettingsMedia->setChecked(false);
    ui->buttonSettingsPrefs->setChecked(false);
    ui->buttonSettingsSecurity->setChecked(false);
}

void SettingsScreen::on_buttonSettingsPrefs_clicked()
{
    clearButtonSelections();
    ui->buttonSettingsPrefs->setChecked(true);
    lightingSettings->setVisible(false);
    climateSettings->setVisible(false);
    prefsSettings->setVisible(true);
    securitySettings->setVisible(false);
    mediaSettings->setVisible(false);
}

void SettingsScreen::on_buttonSettingsMedia_clicked()
{
    clearButtonSelections();
    ui->buttonSettingsMedia->setChecked(true);
    prefsSettings->setVisible(false);
    lightingSettings->setVisible(false);
    climateSettings->setVisible(false);
    securitySettings->setVisible(false);
    mediaSettings->setVisible(true);
}

void SettingsScreen::on_buttonSettingsLighting_clicked()
{
    clearButtonSelections();
    populateLightingZones();
    ui->buttonSettingsLighting->setChecked(true);
    prefsSettings->setVisible(false);
    climateSettings->setVisible(false);
    lightingSettings->setVisible(true);
    securitySettings->setVisible(false);
    mediaSettings->setVisible(false);
}

void SettingsScreen::on_buttonSettingsClimate_clicked()
{
    clearButtonSelections();
    ui->buttonSettingsClimate->setChecked(true);
    prefsSettings->setVisible(false);
    lightingSettings->setVisible(false);
    climateSettings->setVisible(true);
    securitySettings->setVisible(false);
    mediaSettings->setVisible(false);
}

void SettingsScreen::on_buttonSettingsSecurity_clicked()
{
    clearButtonSelections();
    ui->buttonSettingsSecurity->setChecked(true);
    prefsSettings->setVisible(false);
    lightingSettings->setVisible(false);
    climateSettings->setVisible(false);
    securitySettings->setVisible(true);
    mediaSettings->setVisible(false);
}

/***
 ** Overriding focusChanged handler
 ** Filter active widget and if its of a type QLineEdit, show onscreen Keyboard
 **/
void SettingsScreen::focusChanged(QWidget* /*old*/, QWidget* nob)
{
    if(nob){
        if (nob->inherits("QLineEdit")){
            if(keyboard)
            {
                    keyboard->onEnterButtonPressed(keyboard->currentString);
            }
            QLineEdit* lEdit = (QLineEdit*)nob;
            keyboard = new KeyboardWidget();
            keyboard->setReceivingField(lEdit);

            keyboard->setCurrentString(lEdit->text());
            lEdit->setText(QString(""));

            QObject::connect(keyboard, SIGNAL(killKeyboard()), this, SLOT(destroyKeyboard()));
            keyboard->show();
        }
    }
}

void SettingsScreen::destroyKeyboard()
{
    keyboard->deleteLater();
    keyboard = NULL;
}

/***
 ** Set lighting zones if they are changed
 **/
void SettingsScreen::populateLightingZones()
{

    lightingSettings->setZones(climateSettings->getZones());
}

/***
 ** Populate Zones for HVAC ComboBox
 **/
void SettingsScreen::requestedHVACLabels()
{
    climateSettings->getZones();
}


/***
 ** Toggle visibility of menus on Ui
 **/
void SettingsScreen::toggleMenus()
{
    QPropertyAnimation *topMenuAnim = new QPropertyAnimation(ui->topMenuWidget, "geometry");

    // Determine Ui widget position, if pos.x if > height() * .5 widget is on top
    topMenuAnim->setDuration(transition_speed);
    topMenuAnim->setStartValue(ui->topMenuWidget->geometry());

    if (ui->topMenuWidget->pos().x() >= 0) {
        topMenuAnim->setEndValue(QRect(-ui->topMenuWidget->width() + 35, 0, ui->topMenuWidget->width(), ui->topMenuWidget->height()));

    } else {
        topMenuAnim->setEndValue(QRect(0, 0, ui->topMenuWidget->width(), ui->topMenuWidget->height()));
    }

    QParallelAnimationGroup *group = new QParallelAnimationGroup(this);
    group->addAnimation(topMenuAnim);

    connect (group, SIGNAL(finished()), this, SLOT(animFinished()));

    group->start(QAbstractAnimation::DeleteWhenStopped);

}

void SettingsScreen::animFinished()
{
    QPushButton *button = ui->topMenuWidget->findChild<QPushButton *>("toggleButton");

    if (!button) {
        qDebug() << "NULL Widget!";
        return;
    }

    if (ui->topMenuWidget->pos().x() >= 0) {

        QImage img = QImage(":/resources/smallcamera/up.png");
        QMatrix matrix;
        matrix.rotate(-90.);
        img = img.transformed(matrix);
        button->setIcon(QIcon(QPixmap::fromImage(img)));

        ui->verticalLayout_4->setContentsMargins(0, 30, 0, 0);

    } else {

        QImage img = QImage(":/resources/smallcamera/up.png");
        QMatrix matrix;
        matrix.rotate(90.);
        img = img.transformed(matrix);
        button->setIcon(QIcon(QPixmap::fromImage(img)));

        ui->verticalLayout_4->setContentsMargins(0, 0, 0, 0);
    }
}

/***
 ** Run single shot timer to auto hide menus, for small resolution
 **/
void SettingsScreen::runTimer()
{
    // Run only in small resolution
    if (!isSmallResolution)
        return;

    if (timer.isActive()) {
        timer.stop();
    }
    timer.start(2000);
}
